Ecaflip/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf.urls import url
from appli import views

urlpatterns = [
    path('', include('appli.urls')),
    path('admin/', admin.site.urls),
]

appli/urls.py
from django.urls import path


from . import views

app_name = 'appli'
urlpatterns = [
    path('', views.CardsView.as_view(), name='cards'),
    path('cards', views.CardsView.as_view(), name='cards'),
    path('card/<int:pk>', views.CardView.as_view(), name='card'),
    path('crafted/<int:pk>', views.CraftedView.as_view(), name='craft'),
    path('series/', views.SeriesView.as_view(), name='series'),
    path('series/<int:serieNumber>', views.SeriesView.as_view(), name='serie'),
    path('serieFilter', views.serieFilter, name='serieFilter'),
    path('combinations/', views.RecipesCombination.as_view(), name='combinations'),
    path('cardsCombination', views.cardsCombination, name='cardsCombination'),
    path('recipes/', views.RecipesView.as_view(), name='recipes'),
    path('recipes/<int:card1>', views.RecipesView.as_view(), name='recipes'),
    path('recipes/<int:card1>/<int:card2>', views.RecipesView.as_view(), name='recipes'),
    path('recipes/<int:card1>/<int:card2>/<int:card3>', views.RecipesView.as_view(), name='recipes'),
    path('recipes/<int:card1>/<int:card2>/<int:card3>/<int:card4>', views.RecipesView.as_view(), name='recipes'),
    path('recipes/<int:card1>/<int:card2>/<int:card3>/<int:card4>/<int:card5>', views.RecipesView.as_view(), name='recipes'),
]

appli/models.py
from django.db import models
from django.utils import timezone
from django.core.exceptions import ValidationError
from django.core.files import File
from urllib.request import urlopen, Request
from tempfile import NamedTemporaryFile
from django.utils.safestring import mark_safe
from .scrapper_util import *
import time
def update_filename(instance, filename):
    path = "appli/static/images/cards"
    return '{0}/{1}.svg'.format(path, instance.pk)

class Card(models.Model):
    name = models.CharField(max_length=200)
    serie = models.IntegerField()
    obtention = models.CharField(max_length=1500)
    icon = models.ImageField(upload_to=update_filename)
    icon_url = models.URLField()

    def getIconName(self):
        return self.icon.url.split("/")[-1]
    def __str__(self):
        return self.name

    def clean(self):
        cleaned_data = super(Card, self).clean()
        if Card.objects.filter(name=self.name):
            raise ValidationError(
                    "Cette carte existe déjà"
                )

    def admin_image(self):
        src = 'https://www.temporiziovo.fr/static/images/cards/' + str(self.pk) + '.svg'
        return mark_safe('<img src="{}" width="100" />'.format(src))
    admin_image.short_description = 'Image'
    admin_image.allow_tags = True

    #def get_remote_image(self):
     #   if self.icon_url and not self.icon:
      #      img_temp = NamedTemporaryFile(delete=True)
       #     img_temp.write(urlopen(self.icon_url).read())
        #    img_temp.flush()
         #   self.icon.save(f"image_{self.pk}", File(img_temp))
        #self.save()

def update_filename_crafted(instance, filename):
    path = "appli/static/images/crafted"
    return '{0}/{1}.png'.format(path, instance.pk)


class Crafted(models.Model):
    name = models.CharField(max_length=200)
    level = models.IntegerField()
    url = models.CharField(max_length=2000)
    img_url = models.CharField(max_length=2000)
    img = models.ImageField(upload_to=update_filename_crafted)
    craft_type = models.CharField(max_length=100)
    
    def __str__(self):
        return self.name

    def getIconName(self):
        return self.img.url.split("/")[-1]

    #def get_remote_image(self):
        #if self.img_url and not self.img:
            #USER_AGENT = GetHeader()
            #req = Request(self.img_url, headers={'User-Agent': USER_AGENT})
            #time.sleep(random.random())
            #img_temp = NamedTemporaryFile(delete=True)
            #img_temp.write(urlopen(req).read())
            #img_temp.flush()
            #self.img.save(f"image_{self.pk}", File(img_temp))
        #self.save()

class Recipe(models.Model):
    card1 = models.ForeignKey(Card, on_delete=models.CASCADE, related_name='card1')
    card2 = models.ForeignKey(Card, on_delete=models.CASCADE, related_name='card2')
    card3 = models.ForeignKey(Card, on_delete=models.CASCADE, related_name='card3')
    card4 = models.ForeignKey(Card, on_delete=models.CASCADE, related_name='card4')
    card5 = models.ForeignKey(Card, on_delete=models.CASCADE, related_name='card5')
    craft = models.ForeignKey(Crafted, on_delete=models.CASCADE)
    
    def __str__(self):
        return self.craft.name + str(self.pk)


    def clean(self):
        cleaned_data = super(Recipe, self).clean()
        orderedId = [self.card1, self.card2, self.card3, self.card4, self.card5]
        orderedId.sort(key=lambda card: card.pk)
        
        if orderedId[0] == orderedId[1] or orderedId[1] == orderedId[2] or orderedId[2] == orderedId[3] or orderedId[3] == orderedId[4]:
            raise ValidationError(
                "Il y a des doublons"
                )

        self.card1 = orderedId[0]
        self.card2 = orderedId[1]
        self.card3 = orderedId[2]
        self.card4 = orderedId[3]
        self.card5 = orderedId[4]

        matching_data = Recipe.objects.filter(card1__pk=self.card1.pk)
        matching_data = matching_data.filter(card2__pk=self.card2.pk)
        matching_data = matching_data.filter(card3__pk=self.card3.pk)
        matching_data = matching_data.filter(card4__pk=self.card4.pk)
        matching_data = matching_data.filter(card5__pk=self.card5.pk)

        if matching_data.count() > 0:
            raise ValidationError(
                "Cette recette existe déjà, pour réaliser : " + str(matching_data.first().craft.name)
                )

appli/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.core.paginator import Paginator
from django.views.generic.list import MultipleObjectMixin
from django.core.files import File
import os
import urllib.request
from dal import autocomplete

import requests
from bs4 import BeautifulSoup

from .models import Card, Crafted, Recipe
from .dofapi import *


def InitBdd():
    base_url = 'https://tempocraft.altasia.fr/assets/images/cards/224'
    for i in range (1, 655):
        url = base_url
        if i < 10:
            url += "00"
        elif i < 100:
            url += "0"
        url += str(i) + ('.svg')

        name = "?-" + str(i)

        description = "? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?"

        serie = 201

        card = Card(name=name, serie=serie, obtention=description, icon_url = url)

        card.save()
        #card.get_remote_image()

def RenameBdd():
    base_url = "https://tempocraft.altasia.fr/card/224"
    for i in range (1, 655):
        URL = base_url
        if i < 10:
            URL += "00"
        elif i < 100:
            URL += "0"
        URL += str(i)

        id = i + 20

        card = Card.objects.filter(pk=id).first()
        page = requests.get(URL)
        soup = BeautifulSoup(page.content,"html.parser")
        card.name = '???' + soup.find(class_="jumbotron").h1.get_text()
        card.save()

def PopulateRecipe():
    for i in range (1,8000):
        cards = Card.objects.order_by('?')[:5].all()
        cards = list(cards)
        cards.sort(key=lambda card: card.pk)
        card1 = cards[0]
        card2 = cards[1]
        card3 = cards[2]
        card4 = cards[3]
        card5 = cards[4]
        matching_data = Recipe.objects.filter(card1__pk=card1.pk)
        matching_data = matching_data.filter(card2__pk=card2.pk)
        matching_data = matching_data.filter(card3__pk=card3.pk)
        matching_data = matching_data.filter(card4__pk=card4.pk)
        matching_data = matching_data.filter(card5__pk=card5.pk)

        if matching_data.count() == 0:
            crafted = Crafted.objects.order_by('?').first()
            recipe = Recipe(card1=card1, card2=card2, card3=card3, card4=card4, card5=card5, craft=crafted)
            recipe.save()


class CardsView(generic.ListView):
    template_name = 'card_list_big.html'
    paginate_by = 30
    def get_queryset(self):
        if 'serieNumber' in self.kwargs:
            return Card.objects.filter(serie=self.kwargs.get("serieNumber"))
        return Card.objects.order_by('serie')
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        return context

class SeriesView(generic.ListView):
    template_name = 'card_list_big.html'
    paginate_by = 30
    def get_queryset(self):
        if 'serieNumber' in self.kwargs:
            return Card.objects.filter(serie=self.kwargs.get("serieNumber"))
        return Card.objects.order_by('serie')
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        return context

class RecipesCombination(generic.TemplateView):
    template_name = "combination.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        return context

class RecipesView(generic.ListView):
    paginate_by = 10
    template_name = 'recipe_list.html'

    def get_queryset(self):
        recipes = Recipe.objects.all()
        cards = []
        if 'card1' in self.kwargs:
            cards.append(self.kwargs.get('card1'))
        if 'card2' in self.kwargs:
            cards.append(self.kwargs.get('card2'))
        if 'card3' in self.kwargs:
            cards.append(self.kwargs.get('card3'))
        if 'card4' in self.kwargs:
            cards.append(self.kwargs.get('card4'))
        if 'card5' in self.kwargs:
            cards.append(self.kwargs.get('card5'))

        count = len(cards)
        if count == 0:
            return recipes

        for card_pk in cards:
            previous = recipes
            recipes = previous.filter(card1__pk=card_pk)
            recipes2 = previous.filter(card2__pk=card_pk)
            recipes3 = previous.filter(card3__pk=card_pk)
            recipes4 = previous.filter(card4__pk=card_pk)
            recipes5 = previous.filter(card5__pk=card_pk)

            recipes = recipes | recipes2 | recipes3 | recipes4 | recipes5

        return recipes
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        return context


class CardView(generic.DetailView):
    template_name = 'card_detail.html'
    model = Card

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        recipes = Recipe.objects.all()
        pk = kwargs['object'].pk
        containedRecipes = recipes.filter(card1__pk=pk)
        containedRecipes = containedRecipes.union(recipes.filter(card2__pk=pk))
        containedRecipes = containedRecipes.union(recipes.filter(card3__pk=pk))
        containedRecipes = containedRecipes.union(recipes.filter(card4__pk=pk))
        containedRecipes = containedRecipes.union(recipes.filter(card5__pk=pk))
        containedRecipes = containedRecipes.union(recipes.filter(craft__pk=pk))
        paginator = Paginator(containedRecipes.order_by('craft'), 5)
        page = self.request.GET.get('page')
        linkedRecipes = paginator.get_page(page)
        context["page_obj"] = linkedRecipes
        return context

class CraftedView(generic.DetailView):
    template_name = 'craft_detail.html'
    model = Crafted
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["AutocompleteCards"] = Card.objects.all()
        context["AutocompleteCrafts"] = Crafted.objects.all()
        recipes = Recipe.objects.all()
        pk = kwargs['object'].pk
        containedRecipes = recipes.filter(craft=pk)
        context["LinkedRecipes"] = containedRecipes.order_by('craft')
        return context
    

"""
Fetch database from dofapi
"""


def serieFilter(request):
    if request.method == 'POST':
        return HttpResponseRedirect(reverse('appli:serie', kwargs={'serieNumber' : request.POST['choice']}))
    else:
        return HttpResponseRedirect(reverse('appli:series'))


def cardsCombination(request):
    if request.method == 'GET':
        return HttpResponseRedirect(reverse('appli:cards'))

    cards = []
    if 'card1' in request.POST and int(request.POST['card1']) >= 0:
        cards.append(request.POST['card1'])
    if 'card2' in request.POST and int(request.POST['card2']) >= 0:
        cards.append(request.POST['card2'])
    if 'card3' in request.POST and int(request.POST['card3']) >= 0:
        cards.append(request.POST['card3'])
    if 'card4' in request.POST and int(request.POST['card4']) >= 0:
        cards.append(request.POST['card4'])
    if 'card5' in request.POST and int(request.POST['card5']) >= 0:
        cards.append(request.POST['card5'])

    if len(cards) == 0:
        return HttpResponseRedirect(reverse('appli:combinations'))
    if len(cards) == 1:
        return HttpResponseRedirect(reverse('appli:card',  kwargs={'pk': cards[0]}))
    cards.sort()

    kwargs={}
    if len(cards) > 0:
        kwargs['card1'] = cards[0]
    if len(cards) > 1:
        kwargs['card2'] = cards[1]
    if len(cards) > 2:
        kwargs['card3'] = cards[2]
    if len(cards) > 3:
        kwargs['card4'] = cards[3]
    if len(cards) > 4:
        kwargs['card5'] = cards[4]

    
    return HttpResponseRedirect(reverse('appli:recipes', kwargs=kwargs))
    

appli/templates/base.html
{% load static %}
{% load compress %}

<!doctype html>
<html lang="en">

  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-eOJMYsd53ii+scO/bJGFsiCZc+5NDVN2yr8+0RDqr0Ql0h+rP48ckxlpbzKgwra6" crossorigin="anonymous">

    <!-- Normal CSS-->
    {% compress css %}
    <link type="text/x-scss" href="{% static 'style.scss' %}" rel="stylesheet" media="screen">
{% endcompress %}

    <title>Ecaflip Citizyovo</title>
  </head>

  <body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
        <a class="navbar-brand" href="#">Index</a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation" onclick="myFunction(0)">
        <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                <li class="nav-item">
                <a class="nav-link active" href="{% url 'appli:cards' %}">Cartes</a>
                </li>
                <li class="nav-item">
                <a class="nav-link active" href="{% url 'appli:series' %}">Séries</a>
                </li>


                <!-- DROPDOWN de sélection d'une carte ou d'un craft-->
                <li class="nav-item dropdown">

                    <a class="nav-link dropdown-toggle active" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                        Recherche
                    </a>

                    <ul class="dropdown-menu" aria-labelledby="navbarDropdown" id="myDropdown0">
                        <input type="text" placeholder="Search.." id="myInput0" onkeyup="filterFunction(0)">
                        {%for card in AutocompleteCards%}
                            <li>
                                <a class="dropdown-item" href="{%url 'appli:card' card.pk %}">{{card.name}}</a>
                            </li>
                        {%endfor%}

                        {%for craft in AutocompleteCrafts%}
                            <li>
                                <a class="dropdown-item" href="{%url 'appli:craft' craft.pk %}">{{craft.name}}</a>
                            </li>
                        {%endfor%}
                        
                    </ul>
                </li>

                <li class="nav-item">
                  <a class="nav-link active" href="{%url 'appli:combinations'%}">Chercheur de combinaisons</a>
                </li>
            </ul>
        </div>
    </div>
    </nav>
    {%block content%}
    {% endblock %}

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/js/bootstrap.bundle.min.js" integrity="sha384-JEW9xMcG8R+pH31jmWH6WWP0WintQrMb4s7ZOdauHnUtxwoG2vI5DkLtS3qm9Ekf" crossorigin="anonymous"></script>
  
    <script>
    /* When the user clicks on the button,
    toggle between hiding and showing the dropdown content */
    function myFunction(id) {
      document.getElementById("myDropdown"+id).classList.toggle("show");
    }

    function filterFunction(id) {
      var input, filter, ul, li, a, i;
      input = document.getElementById("myInput"+id);
      filter = input.value.toUpperCase();
      div = document.getElementById("myDropdown"+id);
      a = div.getElementsByTagName("a");
      for (i = 0; i < a.length; i++) {
        txtValue = a[i].textContent || a[i].innerText;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
          a[i].style.display = "";
        } else {
          a[i].style.display = "none";
        }
      }
    }
    </script>
  </body>
</html>

appli/templates/card_detail.html
{% extends 'base.html' %}
{% load static %}

{%block content%}

<div class="container-fluid vh-100">
    <div class="w-75 mx-auto big-list-container">

        <div class="row big-list-row mx-auto"></div>

        <div class="row big-list-footer mx-auto">
            <div class="col-2 big-card-img"> <img src="{% static 'images/cards/'%}{{object.getIconName}}"> </img></div> 
            <div class="col-1 h-100 big-card-lvl"> 
                <p> Lvl{{object.serie}}</p> 
            </div> 
            <div class="col-2 h-100 big-card-name"> <p> {{object.name}} </p> </div>
            <div class="col-7 h-100 big-card-desc"> <p> {{object.obtention}} </p> </div> 
        </div>

        <div class="row big-list-row mx-auto"></div>
        {% for recipe in page_obj %}

            <div class="row big-list-footer mx-auto">

                <div class="col-2 recipe-item-1">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.card1.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/cards/'%}{{recipe.card1.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:card' recipe.card1.pk %}" class="stretched-link"></a>
                </div>

                <div class="col-2 recipe-item-2">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.card2.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/cards/'%}{{recipe.card2.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:card' recipe.card2.pk %}" class="stretched-link"></a>
                </div>

                <div class="col-2 recipe-item-3">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.card3.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/cards/'%}{{recipe.card3.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:card' recipe.card3.pk %}" class="stretched-link"></a>
                </div>

                <div class="col-2 recipe-item-4">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.card4.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/cards/'%}{{recipe.card4.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:card' recipe.card4.pk %}" class="stretched-link"></a>
                </div>

                <div class="col-2 recipe-item-5">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.card5.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/cards/'%}{{recipe.card5.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:card' recipe.card5.pk %}" class="stretched-link"></a>
                </div>

                <div class="col-2 recipe-item-6">
                    <div class="row-6 h-25">
                        <div class="recipe-item-text">
                            <p>{{recipe.craft.name}}</p>
                        </div>
                    </div>
                    <div class="row-6 h-75">
                        <div class="recipe-item-img ">
                            <img src="{% static 'images/crafted/'%}{{recipe.craft.getIconName}}"></img>
                        </div>
                    </div>
                    <a href="{%url 'appli:craft' recipe.craft.pk %}" class="stretched-link"></a>
                </div>
            </div>
            
            
        {% endfor %}

        <div class="row big-list-row w-100 justify-content-center mx-auto">
            <div class="col h-100 mx-auto">
                <div class="pagination paginator border border-5">
                    <span class="step-links">
                        {% if page_obj.has_previous %}
                            <a href="?page=1">&laquo; first</a>
                            <a href="?page={{ page_obj.previous_page_number }}">previous</a>
                        {% endif %}

                        <span class="current">
                            Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
                        </span>

                        {% if page_obj.has_next %}
                            <a href="?page={{ page_obj.next_page_number }}">next</a>
                            <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            </div> 
        </div>
    </div>
</div>



{% endblock %}

appli/templates/card_list_big.html
{% extends 'base.html' %}
{% load static %}

{%block content%}


<div class="container-fluid vh-100">
    <div class="mx-auto big-list-container">

        <div class="row big-list-row mx-auto"></div>
        <div class="row big-list-row mx-auto">
            <div class="col-1 h-100 big-list-img"> <p> IMG </p> </div> 
            <div class="col-1 h-100 big-list-lvl"> <p> NIVEAU </p> </div> 
            <div class="col-2 h-100 big-list-name"> <p> NOM </p> </div>
            <div class="col-8 h-100 big-list-desc"> <p> OBTENTION </p> </div> 
        </div>

    <!-- Liste des cartes -->
        {% for card in page_obj %}

            <div class="row big-list-row mx-auto">
                <div class="col-1 h-100 big-list-img"> <img src="{% static 'images/cards/'%}{{card.getIconName}}"> </img></div> 
                <div class="col-1 h-100 big-list-lvl"> <p> Lvl{{card.serie}} </p> </div> 
                <div class="col-2 h-100 big-list-name"> <p> {{card.name}} </p> </div>
                <div class="col-8 h-100 big-list-desc"> <p> {{card.obtention}} </p> </div> 
                <a href="{%url 'appli:card' card.pk %}" class="stretched-link"></a>
            </div>

        {% endfor %}
        <div class="row big-list-row mx-auto"></div>

        <div class="row big-list-footer mx-auto">
            <div class="col-4 h-100">
                <div class="pagination paginator border border-5">
                    <span class="step-links">
                        {% if page_obj.has_previous %}
                            <a href="?page=1">&laquo; first</a>
                            <a href="?page={{ page_obj.previous_page_number }}">previous</a>
                        {% endif %}

                        <span class="current">
                            Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
                        </span>

                        {% if page_obj.has_next %}
                            <a href="?page={{ page_obj.next_page_number }}">next</a>
                            <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            </div> 

            <div class="col-2 h-100"></div> 

            <div class="col-6 h-100">
                <div class="recherche-serie w-100 border border-5">
                    <!-- Formulaire des séries-->
                    <form action="{% url 'appli:serieFilter'%}" method="post">
                        {% csrf_token %}
                        <div class="form-group">
                            <label for="choice">Recherche par série</label>
                            <input type="number" class="form-control form-control-sm" id="choice" name="choice" placeholder="Entrer une série" value="0">
                            <input type="submit" class="btn btn-primary" value="Envoyer">
                        </div>
                    </form>
                </div>
            </div> 
        </div>

    </div>
</div>

{% endblock %}

appli/templates/combination.html
{% extends 'base.html' %}
{% load static %}

{%block content%}

<!-- Formulaire des séries-->
<form action="{% url 'appli:cardsCombination'%}" method="post">
{% csrf_token %}
    <div class="container-fluid vw-100">
        <div class="row mt-5 mb-5">
            {% for i in '12345'|make_list %}
                <div class="col ml-2">
                    <!-- Selection de la carte-->
                    <div class="row">

                        <div class="dropdown d-flex justify-content-center">

                            <div class="dropdown">
                            <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton{{forloop.counter}}" data-bs-toggle="dropdown" aria-expanded="false">
                                    Dropdown button
                                </button>
                                <ul class="dropdown-menu" aria-labelledby="dropdownMenuButton" id="myDropdown{{ forloop.counter }}">
                                    <input type="text" placeholder="Search.." id="myInput{{ forloop.counter }}" onkeyup="filterFunction({{ forloop.counter }})">
                                    <li><a class="dropdown-item" onclick="selectCard({{ i }}, -1, 'Pas de carte', '{%static 'images/defaults/chacha.png' %}')">---</a></li>
                                    {%for card in AutocompleteCards%}
                                    <li><a class="dropdown-item" onclick="selectCard({{ i }}, {{card.pk}}, '{{card.name | slugify}}', '{% static 'images/cards/'%}{{card.getIconName}}')">{{card.name}}</a></li>
                                    {%endfor%}
                                </ul>
                            </div>
                            <input id="field{{ forloop.counter }}" name="card{{ forloop.counter }}" type="hidden" value="-1">
                            <p id="current{{ forloop.counter }}"> </p>
                        </div>

                    </div>

                    <!-- Detail de la carte -->
                    <div class="row-4">
                        <div class="col w-100">
                            <div class="card-picker-container mx-auto">
                                <div class="row-6 card-picker-img ">
                                    <img id="img{{forloop.counter}}" class="img-fluid" src="{%static 'images/defaults/chacha.png' %}" alt="" />
                                </div>
                                <div class="row-6 card-picker-name">
                                    <p id="name{{forloop.counter}}">Pas de carte</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            {%endfor%}
        </div>

        <div class="d-grid gap-2 row mx-auto w-25">
            <button class="btn btn-primary" type="submit">RECHERCHE</button>
        </div>

    </div>
</form>





<script>
    /* When the user clicks on the button,
    toggle between hiding and showing the dropdown content */
    function selectCard(forloop, id, name, url) {
      document.getElementById("field"+forloop).value = id;
      document.getElementById("name"+forloop).innerText = name ;
      document.getElementById("img"+forloop).src = url;
    }
</script>

{% endblock %}